package com.casic.dcms.mvp.model;

import com.casic.dcms.bean.CaseHandledBean;
import com.casic.dcms.utils.retrofit.RetrofitServiceManager;

import rx.Observable;
import rx.Observer;
import rx.Subscription;
import rx.android.schedulers.AndroidSchedulers;
import rx.schedulers.Schedulers;

public class CaseHandledListModelImpl implements ICaseHandledListModel {

    private OnGetCaseHandledListListener listener;

    public CaseHandledListModelImpl(OnGetCaseHandledListListener caseHandledListListener) {
        this.listener = caseHandledListListener;
    }

    public interface OnGetCaseHandledListListener {
        void onSuccess(CaseHandledBean resultBean);

        void onFailure(Throwable throwable);
    }

    @Override
    public Subscription sendRetrofitRequest(int offset) {
        Observable<CaseHandledBean> observable = RetrofitServiceManager.getCaseHandledListResult(offset);
        return observable.subscribeOn(Schedulers.io()).observeOn(AndroidSchedulers.mainThread()).subscribe(new Observer<CaseHandledBean>() {
            @Override
            public void onCompleted() {

            }

            @Override
            public void onError(Throwable e) {
                if (e.getCause() != null) {
                    listener.onFailure(e);
                }
            }

            @Override
            public void onNext(CaseHandledBean resultBean) {
                if (resultBean != null) {
                    listener.onSuccess(resultBean);
                }
            }
        });
    }
}
